import mimetypes

import requests
from flask import make_response, request, abort
from flask_restful import Resource

from app.configs import config


class AgentApi(Resource):

    def get(self, path):
        token = request.args.get('token', None)
        if token is None:
            abort(418)

        # 验证token
        validate_token_rep = requests.get('http://%s/oauth/api/user/validateToken' % config.OAUTH_HOST,
                                          headers={'token': token}).json()
        if validate_token_rep.get('code') != 200:
            return validate_token_rep
        # 请求nginx
        nginx_rep = requests.get('http://%s/%s' % (config.NGINX_HOST, path))
        response = make_response(nginx_rep.content)
        filename = path.split('/')[-1]
        mime_type = mimetypes.guess_type(filename)[0]
        if mime_type is None:
            mime_type = 'application/octet-stream'
        response.headers['Content-Type'] = mime_type
        response.headers['Content-Disposition'] = 'attachment; filename={}'.format(filename.encode().decode('latin-1'))
        return response
